#!/usr/bin/perl

# Simple median filter
# Smooths l1_logreg results

#
#  Copyright (C) 2008  Molly Megraw
# 
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
#  Contact: molly.megraw@duke.edu
#  
#

$hw = shift; # half-window size over which to smooth
$res = shift; # results file
$outfile = shift; # output file

open(OUT, ">$outfile");
open(IN, "$res") || die "Can't open $res";
# read through header
$line = <IN>;
while ($line =~ /^\%/) {
    print OUT $line;
    $line = <IN>;
}
print OUT $line;
# read value vector
@arr = ();
for $i ( 0 .. 2*$hw) {
    $line = <IN>;
    chomp($line);
    $line =~ s/^\s+//; # remove leading whitespace
    $arr[$i] = $line;
    if ($i < $hw) { print OUT " $arr[$i]\n"; }
}
@sorted = sort {$a <=> $b} @arr;
$median = $sorted[($#sorted / 2)];
print OUT " $median\n";

while (<IN>) {
    $line = $_;
    chomp($line);
    $line =~ s/^\s+//; # remove leading whitespace
    shift(@arr);
    push(@arr, $line);
    @sorted = sort {$a <=> $b} @arr;
    $median = $sorted[($#sorted / 2)];
    print OUT " $median\n";
}
for $i ( ($#arr - $hw + 1) .. $#arr) {
    print OUT " $arr[$i]\n";
}

close(IN);
close(OUT);
